#
# Rules and settings specific to (Microsoft) cl and similar compilers
#
ASM                    := .asm
OBJ                    := .obj
EXE                    := .exe
LIBEXT                 := .lib
DLLEXT                 := .dll

# On Windows, shared objects (dlls) are stored in the binary directory
DLLDIR                 := $(BINDIR)
DLLPAT                 := $(BINPAT)
DLLPATH                := $(BINPATH)

# As CC, CXX and LD are pre-defined by gmake by default, using ?= so that the
# Makefile can override them won't work.
ifeq ($(origin CC),default)
ifneq ($(COMP),)
CC                     := $(COMP)
else
CC                     := cl
endif
endif
ifeq ($(origin CXX),default)
ifneq ($(COMP),)
CXX                    := $(COMP)
else
CXX                    := cl
endif
endif
ifeq ($(origin LD),default)
LD                     := link
endif
LXX                    ?= link

# Functions to generate appropriate names. Note that libname and dllname
# are from the perspective of the linker, i.e. the names of the files that
# the linker requires. This makes a difference on Windows, where you link
# against .lib, not the .dll used during runtime.
asmname                ?= $(1)$(ASM)
objname                ?= $(1)$(OBJ)
outname                ?= $(1)$(EXE)
libname                ?= $(1)$(LIBEXT)
dllname                ?= $(1)$(LIBEXT)

# Functions to generate the correct command line switches
adddef                 ?= /D"$(1)"
addipath               ?= /I"$(1)"
addlpath               ?= /LIBPATH:"$(1)"
addlib                 ?= $(call libname,$(1))
objout                 ?= /c /Fo"$(1)"
exeout                 ?= /OUT:$(1)
dllout                 ?= /DLL /OUT:$(1)
lstatic                ?=
ldynamic               ?=
debug                  ?= /Zi /Fd$(OBJPATH) $(1)
ldebug                 ?= /DEBUG /PDB:$(BINPATH) $(1)
profile                ?= $(1)
lprofile               ?= $(1)

# Also look for source files in the 'generated' directory.
vpath %.c               $(GENDIR)
vpath %.cpp             $(GENDIR)
vpath %.cc              $(GENDIR)

# Generic rules
$(OBJPAT)$(OBJ): %.c | $(OBJDIR) ; $(CCCMD)

$(OBJPAT)$(OBJ): %.cc | $(OBJDIR) ; $(CXXCMD)

$(OBJPAT)$(OBJ): %.cpp | $(OBJDIR) ; $(CXXCMD)
