#
# aarch64-linux-gcc49
#
# Target specific makefile
#
ifneq ($(NATIVE),yes)
SDK_PATH               := /proj/he/opt/gcc-linaro-4.9-2014.11-x86_64_aarch64-linux-gnu
TARGET_PREFIX          := aarch64-linux-gnu-
PATH                   := $(SDK_PATH)/bin:$(PATH)
endif

TARGET_ARCHFLAGS        = -march=armv8-a -mfix-cortex-a53-835769
TARGET_OPTFLAGS         = -O3
TARGET_CPPFLAGS         = -DLINUX
TARGET_CFLAGS           = -Wall -Wno-strict-aliasing -pipe $(TARGET_ARCHFLAGS)

# Extra flags when dealing with static libraries
ifeq ($(STATIC),yes)
TARGET_CFLAGS          += -ffunction-sections -fdata-sections
TARGET_LDFLAGS         += -Wl,--gc-sections
endif

# When linking with HALCON, some extra libraries are required. Static HALCON
# libraries will require even more extra system libraries.
ifneq ($(HALCON_LIBDIR),)
TARGET_LDLIBS          += -ldl -lpthread
ifneq ($(filter yes,$(STATIC)),)
TARGET_LDLIBS          += -lrt -lm
endif
endif

# The C++ flags are derived from the C flags
TARGET_CPPXXFLAGS      := $(TARGET_CPPFLAGS)
TARGET_CXXFLAGS        := $(TARGET_CFLAGS)
TARGET_LXXLIBS         := $(TARGET_LDLIBS)
TARGET_LXXFLAGS        := $(TARGET_LDFLAGS)
