#
# armv7hfneon-linux-gcc48
#
# Target specific makefile
#
ifneq ($(NATIVE),yes)
SDK_PATH                = /proj/he/opt/eldk-5.5/armv7a-hf/sysroots
SYSROOT                 = $(SDK_PATH)/armv7ahf-vfp-neon-linux-gnueabi
TARGET_PREFIX           = arm-linux-gnueabi-
PATH                   := $(SDK_PATH)/i686-eldk-linux/usr/bin/arm-linux-gnueabi:$(PATH)
endif

TARGET_ARCHFLAGS        = -march=armv7-a -mtune=cortex-a8 -mfpu=neon -marm \
                          -mfloat-abi=hard
TARGET_OPTFLAGS         = -O3
TARGET_CPPFLAGS         = -DLINUX
TARGET_CFLAGS           = -Wall -Wno-strict-aliasing -pipe $(TARGET_ARCHFLAGS)

TARGET_DEBUGFLAGS       = -gstabs -mlong-calls

# Extra flags when dealing with static libraries
ifeq ($(STATIC),yes)
TARGET_CFLAGS          += -ffunction-sections -fdata-sections
TARGET_LDFLAGS         += -Wl,--gc-sections
endif

# When linking with HALCON, some extra libraries are required. Static HALCON
# libraries will require even more extra system libraries.
ifneq ($(HALCON_LIBDIR),)
TARGET_LDLIBS          += -ldl -lpthread
ifneq ($(filter yes,$(STATIC)),)
TARGET_LDLIBS          += -lrt -lm
endif
endif

# The C++ flags are derived from the C flags
TARGET_CPPXXFLAGS      := $(TARGET_CPPFLAGS)
TARGET_CXXFLAGS        := $(TARGET_CFLAGS)
TARGET_LXXLIBS         := $(TARGET_LDLIBS)
TARGET_LXXFLAGS        := $(TARGET_LDFLAGS)
