#
# x64-linux.mak
#
# Target specific makefile
#

# If TARGET_COMPILER is not defined, set it to gcc.
ifeq ($(TARGET_COMPILER),)
  TARGET_COMPILER      := gcc
endif

# Check for compiler to use. Note that if COMP is set, this will override
# any setting for CC or CXX.
ifeq ($(COMP),icc)

# Extend the PATH so that desired version of icc and ifort are found.
# INTEL_PATH             := /opt/intel/composer_xe_2011_sp1.8.273
INTEL_PATH             := /opt/intel/compilers_and_libraries_2016.1.150/linux
GCC_PATH               := /soft/dist/gcc-4.8-x64
INTEL_PLATFORM         := intel64
PATH                   := $(INTEL_PATH)/bin/$(INTEL_PLATFORM):$(PATH)
CC                     := icc
CXX                    := icpc
LD                     := icc
LXX                    := icpc

TARGET_CFLAGS          := -gcc-name=$(GCC_PATH)/bin/gcc
TARGET_CXXFLAGS        := -gxx-name=$(GCC_PATH)/bin/g++ -cxxlibs
TARGET_LDFLAGS         := -static-intel -no-cxxlib
TARGET_LXXFLAGS        := -static-intel

endif

TARGET_OPTFLAGS         = -O3

# When linking with HALCON, some extra libraries might be required. When using
# a static HALCON library, even more extra libraries are required.
ifneq ($(HALCON_LIBDIR),)
TARGET_LDLIBS          := -lX11 -lXext

ifeq ($(STATIC), yes)
TARGET_LDFLAGS         += -Wl,--gc-sections
TARGET_LDLIBS          += -lm -lrt -ldl -lpthread
endif

endif

TARGET_LXXLIBS         := $(TARGET_LDLIBS)
