#
# x64-macos.mak
#
# Target specific makefile
#

# Check for compiler to use. Note that if COMP is set, this will override
# any setting for CC or CXX.
ifeq ($(COMP),icc)

# Extend the PATH so that desired version of icc and ifort are found.
# Note that for some bizarre reason, the PATH *MUST* be put in double quotes,
# otherwise you may get the error 'Unknown option: GLOB_compiler_bin_directory'
INTEL_PATH             := /opt/intel/composer_xe_2011_sp1.8.269
INTEL_PLATFORM         := intel64
PATH                   := "$(INTEL_PATH)/bin/$(INTEL_PLATFORM):$(PATH)"
CC                     := icc
CXX                    := icpc
LD                     := icc
LXX                    := icpc

TARGET_CFLAGS          := -gcc-version=420
TARGET_CXXFLAGS        := $(TARGET_CFLAGS) -cxxlibs
TARGET_LDFLAGS         := -static-intel
TARGET_LXXFLAGS        := -static-intel

else ifeq ($(COMP),clang)

CC                     := clang
CXX                    := clang++
LD                     := clang
LXX                    := clang++

endif

# Libraries are named differently on MacOS X.
DLLEXT                  = .dylib
libname                ?= lib$(1).dylib

TARGET_OPTFLAGS         = -O3
